-- GENERATED by C->Haskell Compiler, version 0.16.3 Crystal Seed, 24 Jan 2009 (Haskell)
-- Edit the ORIGNAL .chs file instead!


{-# LINE 1 ".\\HGamer3D\\Bindings\\Ogre\\ClassAnimationStateSet.chs" #-}{-# LANGUAGE ForeignFunctionInterface #-}
{-# LANGUAGE TypeSynonymInstances #-}

-- This source file is part of HGamer3D
-- (A project to enable 3D game development in Haskell)
-- For the latest info, see http://www.althainz.de/HGamer3D.html
-- 

-- (c) 2011, 2012 Peter Althainz
-- 
-- Licensed under the Apache License, Version 2.0 (the "License");
-- you may not use this file except in compliance with the License.
-- You may obtain a copy of the License at
-- 
--     http://www.apache.org/licenses/LICENSE-2.0
-- 
-- Unless required by applicable law or agreed to in writing, software
-- distributed under the License is distributed on an "AS IS" BASIS,
-- WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-- See the License for the specific language governing permissions and
-- limitations under the License.
-- 


-- ClassAnimationStateSet.chs

-- 

module HGamer3D.Bindings.Ogre.ClassAnimationStateSet where

import Foreign
import Foreign.Ptr
import Foreign.C

import HGamer3D.Data.HG3DClass
import HGamer3D.Data.Vector
import HGamer3D.Data.Colour
import HGamer3D.Data.Angle

import HGamer3D.Bindings.Ogre.Utils
{-# LINE 40 ".\\HGamer3D\\Bindings\\Ogre\\ClassAnimationStateSet.chs" #-}
import HGamer3D.Bindings.Ogre.ClassPtr
{-# LINE 41 ".\\HGamer3D\\Bindings\\Ogre\\ClassAnimationStateSet.chs" #-}
import HGamer3D.Bindings.Ogre.StructHG3DClass
{-# LINE 42 ".\\HGamer3D\\Bindings\\Ogre\\ClassAnimationStateSet.chs" #-}

-- | 
delete :: HG3DClass  -- ^ classpointer - pointer of Class instance which is going to be deleted.
  ->  IO ()
 -- ^ 
delete a1 =
  withHG3DClass a1 $ \a1' -> 
  delete'_ a1' >>= \res ->
  return ()
{-# LINE 47 ".\\HGamer3D\\Bindings\\Ogre\\ClassAnimationStateSet.chs" #-}

-- | Create a new AnimationState instance. 
--
createAnimationState :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  String  -- ^ animName - The name of the animation 
  ->  Float  -- ^ timePos - Starting time position 
  ->  Float  -- ^ length - Length of the animation to play 
  ->  Float  -- ^ weight - Weight to apply the animation with 
  ->  Bool  -- ^ enabled - Whether the animation is enabled 
  ->  IO (HG3DClass)
 -- ^ 
createAnimationState a1 a2 a3 a4 a5 a6 =
  withHG3DClass a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  let {a3' = realToFrac a3} in 
  let {a4' = realToFrac a4} in 
  let {a5' = realToFrac a5} in 
  let {a6' = fromBool a6} in 
  alloca $ \a7' -> 
  createAnimationState'_ a1' a2' a3' a4' a5' a6' a7' >>= \res ->
  peek  a7'>>= \a7'' -> 
  return (a7'')
{-# LINE 57 ".\\HGamer3D\\Bindings\\Ogre\\ClassAnimationStateSet.chs" #-}

-- | Get an animation state by the name of the animation. 
getAnimationState :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  String  -- ^ name
  ->  IO (HG3DClass)
 -- ^ 
getAnimationState a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  alloca $ \a3' -> 
  getAnimationState'_ a1' a2' a3' >>= \res ->
  peek  a3'>>= \a3'' -> 
  return (a3'')
{-# LINE 63 ".\\HGamer3D\\Bindings\\Ogre\\ClassAnimationStateSet.chs" #-}

-- | Tests if state for the named animation is present. 
hasAnimationState :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  String  -- ^ name
  ->  IO (Bool)
 -- ^ 
hasAnimationState a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  alloca $ \a3' -> 
  hasAnimationState'_ a1' a2' a3' >>= \res ->
  peekBoolUtil  a3'>>= \a3'' -> 
  return (a3'')
{-# LINE 69 ".\\HGamer3D\\Bindings\\Ogre\\ClassAnimationStateSet.chs" #-}

-- | Remove animation state with the given name. 
removeAnimationState :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  String  -- ^ name
  ->  IO ()
 -- ^ 
removeAnimationState a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  removeAnimationState'_ a1' a2' >>= \res ->
  return ()
{-# LINE 74 ".\\HGamer3D\\Bindings\\Ogre\\ClassAnimationStateSet.chs" #-}

-- | Remove all animation states. 
removeAllAnimationStates :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO ()
 -- ^ 
removeAllAnimationStates a1 =
  withHG3DClass a1 $ \a1' -> 
  removeAllAnimationStates'_ a1' >>= \res ->
  return ()
{-# LINE 78 ".\\HGamer3D\\Bindings\\Ogre\\ClassAnimationStateSet.chs" #-}

-- | Copy the state of any matching animation states from this to another. 
copyMatchingState :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  HG3DClass  -- ^ target
  ->  IO ()
 -- ^ 
copyMatchingState a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  withHG3DClass a2 $ \a2' -> 
  copyMatchingState'_ a1' a2' >>= \res ->
  return ()
{-# LINE 83 ".\\HGamer3D\\Bindings\\Ogre\\ClassAnimationStateSet.chs" #-}

-- | Tests if exists enabled animation state in this set. 
hasEnabledAnimationState :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO (Bool)
 -- ^ 
hasEnabledAnimationState a1 =
  withHG3DClass a1 $ \a1' -> 
  alloca $ \a2' -> 
  hasEnabledAnimationState'_ a1' a2' >>= \res ->
  peekBoolUtil  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 88 ".\\HGamer3D\\Bindings\\Ogre\\ClassAnimationStateSet.chs" #-}


foreign import ccall safe "HGamer3D\\Bindings\\Ogre\\ClassAnimationStateSet.chs.h ogre_ass_destruct"
  delete'_ :: ((HG3DClassPtr) -> (IO ()))

foreign import ccall safe "HGamer3D\\Bindings\\Ogre\\ClassAnimationStateSet.chs.h ogre_ass_createAnimationState"
  createAnimationState'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> (CFloat -> (CFloat -> (CFloat -> (CInt -> ((HG3DClassPtr) -> (IO ()))))))))

foreign import ccall safe "HGamer3D\\Bindings\\Ogre\\ClassAnimationStateSet.chs.h ogre_ass_getAnimationState"
  getAnimationState'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> ((HG3DClassPtr) -> (IO ()))))

foreign import ccall safe "HGamer3D\\Bindings\\Ogre\\ClassAnimationStateSet.chs.h ogre_ass_hasAnimationState"
  hasAnimationState'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> ((Ptr CInt) -> (IO ()))))

foreign import ccall safe "HGamer3D\\Bindings\\Ogre\\ClassAnimationStateSet.chs.h ogre_ass_removeAnimationState"
  removeAnimationState'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\Ogre\\ClassAnimationStateSet.chs.h ogre_ass_removeAllAnimationStates"
  removeAllAnimationStates'_ :: ((HG3DClassPtr) -> (IO ()))

foreign import ccall safe "HGamer3D\\Bindings\\Ogre\\ClassAnimationStateSet.chs.h ogre_ass_copyMatchingState"
  copyMatchingState'_ :: ((HG3DClassPtr) -> ((HG3DClassPtr) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\Ogre\\ClassAnimationStateSet.chs.h ogre_ass_hasEnabledAnimationState"
  hasEnabledAnimationState'_ :: ((HG3DClassPtr) -> ((Ptr CInt) -> (IO ())))
